/*
 * Copyright (c) 2019 Exploratory Engineering
 */
#include <zephyr.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <string.h>
#include <at_cmd.h>


static struct k_work my_switch_work;

#define SWITCH_INTERVAL_SEC 10
#define QUEUE_START_WAIT_TIME_SEC 1

int switch_count=0;
void my_switch_work_handler(struct k_work *work)
{
  if(switch_count%2==0){
	  printk("Turn off radio link\n");
	  at_cmd_write("AT+CFUN=4", NULL, 0, NULL);
  }
  else{
	  printk("Turn on radio link\n");
	  at_cmd_write("AT+CFUN=1", NULL, 0, NULL);
  }
  switch_count++;

}

void my_sample_timer_handler(struct k_timer *dummy)
{
	printk("Enter my_sample_timer_handler\n");
	printk("Submit my_switch_work\n");
	k_work_submit(&my_switch_work);

}

K_TIMER_DEFINE(my_sample_timer, my_sample_timer_handler, NULL);
static void work_init(void)
{
	k_work_init(&my_switch_work, my_switch_work_handler);
}
void main() {
	printk("start\n");
	work_init();
	printk("Turn on radio link\n");
	at_cmd_write("AT+CFUN=1", NULL, 0, NULL);
	k_timer_start(&my_sample_timer, K_SECONDS(QUEUE_START_WAIT_TIME_SEC), K_SECONDS(SWITCH_INTERVAL_SEC));
	while (true) {
	}
}
